//
//  ASGameClient.h
//  Alphabet Salad
//
//  Created by Marian Goldeen on 2/28/05.
//  Copyright 2005 Marian Goldeen. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define MIN_WORD_LENGTH 4

typedef enum _BGWordValue {
	BGWordOK, 
	BGWordTooShort, 
	BGWordQ, 
	BGWordRepeated, 
	BGWordDisallowedIllegalLetter, 
	BGWordDisallowedLetterMissing, 
	BGWordDisallowedLetterNotAdjacent, 
	BGWordDisallowedLetterRepeated,
	BGWordGibberish, 
	BGWordNone
} BGWordValue;


@class ASGameDocument;
@class BGTray;
@class BGFinder;
@class BGWord;
@class BGNode;

@interface ASGameClient : NSObject {
	ASGameDocument *_document;
	
	NSMutableArray *_saladList, *_localList;
	
	BGTray *_tray;
	BGFinder *_finder;
}

- initWithDocument:(ASGameDocument *)theDocument;

- (BGWordValue)submitWord:(NSString *)word;
- (void)removeWord:(BGWord *)bgWord;
- (void)setAllowedStateOfWord:(BGWord *)bgWord to:(BOOL)flag;
- (void)resetScore;
- (void)startNewGameWithTrayRepresentation:(NSDictionary *)rep;
- (void)loadSaladListFromNode:(BGNode *)startNode;

- (int)score;
- (NSArray *)saladList;
- (NSArray *)hintList;
- (NSArray *)localList;
- (BGTray *)tray;

- (void)setSaladList:(NSMutableArray *)newArray;
- (void)setLocalList:(NSMutableArray *)newArray;

@end
