/* ASGameDocumentController */

#import <Cocoa/Cocoa.h>

@class ASServerController;

@interface ASGameDocumentController : NSDocumentController
{
	IBOutlet NSWindow *gameListWindow, 
		*welcomeWindow;
	IBOutlet NSTableView *gameListTV;
	IBOutlet NSProgressIndicator *rendezvousPI;
	IBOutlet NSTextField *messageField;
	IBOutlet NSButton *serverButton, 
		*joinButton; 
//		*solitaireCheckbox;
	IBOutlet NSMatrix *playerModeMatrix;
	IBOutlet NSPanel *_portMessagePanel;
	NSWindowController *_portMessagePanelController;
	
	NSInvocation *_documentInvocation, // either openDocument or newDocument for netServiceBrowserDidStopSearch to call
		 *_followupInvocation; // openSaladBoard called on a document in netServiceBrowserDidStopSearch
	NSConnection *_localServerConnection;
	id _localServer;
	NSMutableDictionary *_availableGames;
	NSMutableSet *_gameNames;
	NSString *_selectedGame; // key server and connection in above dictionary
	NSNetServiceBrowser *_netBrowser;
	ASServerController *_serverController;
	NSString *_serverButtonTitle;
	NSMutableDictionary *_netServiceResolveTimers;
	BOOL _joinButtonEnabled, 
		_isMultiplayer, 
		_isAppQuitting, 
		_displayWelcomeWindow;
}

- (IBAction)start:(id)sender;
- (IBAction)toggleGameServer:(id)sender;
- (IBAction)toggleMode:(id)sender;
//- (IBAction)toggleGameMembership:(id)sender;

- (IBAction)changeShowPortMessageDefaultValue:(id)sender;
- (IBAction)runSpellingPanel:(id)sender;
- (void)loadBoard:(id)sender;

- (void)presentSelectedGame;
- (NSMutableDictionary *)gameInfoForSelectedGame;
- (id)localServer;
- (NSConnection *)localServerConnection;
//- (NSButton *)solitaireCheckbox;

- (NSTableView *)gameListTV;
- (NSString *)serverButtonTitle;
- (void)setServerButtonTitle:(NSString *)newTitle;
- (NSString *)gameModeMenuItemTitle;
- (BOOL)joinButtonEnabled;
- (void)setJoinButtonEnabled: (BOOL)flag;
- (BOOL)isMultiplayer;
- (void)setIsMultiplayer: (BOOL)flag;

- (void)setSelectedGame:(NSString *)gameKey;
- (void)addGameName:(NSString *)name;
- (void)removeGameName:(NSString *)name;

@end
