//
//  ASGameServer.h
//  Alphabet Salad
//
//  Created by Marian Goldeen on 2/28/05.
//  Copyright 2005 Marian Goldeen. All rights reserved.
//

#import <Cocoa/Cocoa.h>

typedef enum _BGGameState {
	BGGameWaiting, 
	BGGameRunning, 
	BGGamePaused, 
	BGGameEnded
} BGGameState;


@class ASServerController;
@class BGTray;
@class BGTimer;

@interface ASGameServer : NSObject {
	ASServerController *_controller;
	BGTray *_tray;
	BGGameState _gameState;
//	BOOL solitaire;
}

+ (BGTimer *)timer;

- initWithController:(ASServerController *)theController;

- (BGTray *)tray;
- (BGGameState)gameState;
//- (BOOL)solitaire;

- (void)setGameState:(BGGameState)state;
//- (void)setSolitaire:(BOOL) flag;

- (void)toggleGame;
- (void)startGameWithBoardRepresentation:(NSDictionary *)rep;
- (void)loadBoardRepresentation:(NSDictionary *)rep;

@end
