/* ASPlayersListController */

#import <Cocoa/Cocoa.h>

@class ASShallowPlayer;
@class ASGameDocument;

@interface ASPlayersListController : NSObject
{
    IBOutlet NSPanel *playersListPanel;
    IBOutlet NSTableView *playersListTV;
	IBOutlet NSDrawer *wordListDrawer;
	IBOutlet NSTableView *wordListTV;
	
	NSWindowController *_playersListPanelController;
	BOOL _playersListPanelOpen;
	NSMutableSet *_players;
	ASGameDocument *_document;
	
	NSString *_nameOfSelectedPlayer;
}

- initWithDocument:(ASGameDocument *)theDoc;

- (void)showWordList:(id)sender;
- (void)showWordOnTray:(id)sender;

- (void)showPlayersListPanel;
- (void)closePlayersListPanel;
- (void)destroyPlayersList;
- (void)refresh;
- (void)resetPlayerScores;

- (ASShallowPlayer *)playerNamed:(NSString *)name;
- (void)addPlayerNamed:(NSString *)name;
- (void)removePlayerNamed:(NSString *)name;
- (int)playersCount;

- (void)setNameOfSelectedPlayer:(NSString *)name;

- (BOOL)playersListPanelOpen;
@end
