//
//  ASScoreKeeper.h
//  Alphabet Salad
//
//  Created by Marian Goldeen on 2/28/05.
//  Copyright 2005 Marian Goldeen. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class ASServerController;
@class BGWord;
@class ASPlayer;

@interface ASScoreKeeper : NSObject {
	ASServerController *_controller;
	ASPlayer *_pendingPlayer;
	NSMutableDictionary *_players;
}

- initWithController:(ASServerController *)theController;

- (NSMutableDictionary *)players;
- (void)setPlayers:(NSMutableDictionary *)newPlayers;

- (void)updateScoreWithNewWord:(BGWord *)word forPlayerNamed:(NSString *)playerKey;
- (void)removeWord:(BGWord *)bgWord;
- (void)addRemotePlayer:(id)remote named:(NSString *)playerKey;
//- (void)playerNamed:(NSString *)playerName accepted:(BOOL)accepted;
- (void)removePlayerNamed:(NSString *)name;
//- (BOOL)enforceSolitaireGame;

- (void)broadcastInvocation:(NSInvocation *)invocation;

- (void)resetScore;
- (void)closeGame;
- (void)startNewGame;
- (void)foldAllPlayers;
- (void)broadcastNewTimeAllowed:(int)newTime;
- (void)broadcastNumberOfPlayers:(int)multiplicity;
- (void)broadcastAddedPlayerNamed:(NSString *)name;
- (void)broadcastRemovedPlayerNamed:(NSString *)name;
- (void)broadcastMessage:(NSString *)message fromPlayerNamed:(NSString *)playerKey;
- (void)toggleTimerRequestedByPlayerNamed:(NSString *)playerKey;
- (void)resumeGameRequestedBy:(NSString *)playerKey;
- (NSArray *)refusingPlayersForRequestBy:(NSString *)playerKey;
- (void)announceRefusingPlayers:(NSArray *)refusingPlayers toRequestingPlayer:(NSString *)playerKey;
- (void)pauseGameRequestedBy:(NSString *)playerKey;
- (void)resumeGame;
@end
