//
//  BGDictionary.h
//  Boggo
//
//  Created by Marian Goldeen on 11/20/04.
//  Copyright 2004 Marian Goldeen. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface BGDictionary : NSObject {
	NSString *_wordInQuestion;
	NSWindowController *_korrectionPanelController;
	IBOutlet NSPanel *_korrectionPanel;
	
	BOOL _buttonEnabled;
	BOOL _wordKorrect;
}

+ (BGDictionary *)englishDictionary;

- (IBAction)checkWord:(id)sender;
- (IBAction)updateDictionary:(id)sender;

- (void)removeWord:(NSString *)word;
- (void)addWord:(NSString *)word;

- (BOOL)wordInDictionary:(NSString *)word;
- (NSArray *)completionsOfFragment:(NSString *)fragment;
- (void)runSpellingPanel;
- (void)closeSpellingPanel;

- (NSString *)wordInQuestion;
- (void)setWordInQuestion:(NSString *)word;

- (NSString *)panelMessage;
- (NSString *)buttonTitle;
- (BOOL)buttonEnabled;
- (void)setButtonEnabled:(BOOL)flag;
- (BOOL)wordKorrect;
- (void)setWordKorrect:(BOOL)flag;
@end
