/* BGDie */

#import <Foundation/Foundation.h>

#define POINTS_ON_A_COMPASS 4

typedef enum  {
	north, east, south, west
} BGDieOrientation;

@interface BGDie : NSObject
{
	unsigned int _indexOfVisibleLetter;
	NSArray *_letters;
	BGDieOrientation _orientation;
	
	NSString *_customLetter;
}

- initWithLetters:(NSArray *)theLetters;
- initWithString:(NSString *)stringOfSixLetters;
- initWithDictionary:(NSDictionary *)rep;

-(NSString *)visibleLetter;
-(BGDieOrientation)orientation;
-setDieOrientation:(BGDieOrientation)direction;
-setLetters:(NSArray *)newLetters;
-setCustomLetter:(NSString *)overrideLetter;

- (NSDictionary *)dictionaryRepresentation;

-shake;

@end
