/* BGTray */

#import <Foundation/Foundation.h>
#import "BGNode.h"
#import "BGDie.h"

#define TRAY_EDGE_SIZE 5

@interface BGTray : NSObject
{
	NSArray *_dice, *_nodes;
}

- initWithShallowDice;

- shake;
- (NSArray *)nodes;
- (NSArray *)neighborsForNode:(BGNode *)node;
- (BGNode *)nodeWithPosition:(BGNodePair)position;
- (BGNode *)nodeWithTag:(int)tag;
- (BGNode *)nodeWithVisibleLetter:(NSString *)letter afterNode:(BGNode *)node;
- (int)tagForPosition:(BGNodePair)position;
- (NSDictionary *)saladBoardRepresentation;
- (BOOL)loadSaladBoardRepresentation:(NSDictionary *)rep;
- (NSString *)stringOfVisibleLettersInRow:(unsigned int) row;
@end
